



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Boost - 从Coroutine2 到Fiber</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Boost - 从Coroutine2 到Fiber</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-20 17:44:07 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>Boost - 从Coroutine2 到Fiber</h2>
<h2>协程引子</h2>
<p>我开始一直搞不懂协程是什么，网上搜一搜，(尤其是Golang的goroutine)感觉从概念上听起来有点像线程池，尤其是类似Java的ExcutorService类似的东西</p>
<pre class="prettyprint linenums"><code>package helloworld;

import java.util.Calendar;<br />
import java.util.Date;<br />
import java.util.concurrent.Callable;<br />
import java.util.concurrent.ExecutorService;<br />
import java.util.concurrent.Executors;<br />
import java.util.concurrent.Future;

public class CallMe {<br />
	static class Call implements Callable&lt;String&gt;{

		@Override<br />
		public String call() throws Exception {<br />
			Date d = Calendar.getInstance().getTime();<br />
			return d.toString();<br />
		}

	}

	public static void main(String[] args) throws Exception{<br />
		ExecutorService pool = Executors.newSingleThreadExecutor();<br />
		Future&lt;String&gt; str = pool.submit(new Call());<br />
		pool.shutdown();<br />
		String ret = str.get();<br />
		System.out.println(ret);<br />
	}<br />
}<br />
</code></pre>
<pre class="prettyprint linenums"><code>package main

import (<br />
	&quot;fmt&quot;<br />
	&quot;time&quot;<br />
)

func CallMe(pipe chan string) {<br />
	t := time.Now()<br />
	pipe &lt;- t.String()<br />
}

func main() {<br />
	pipe := make(chan string, 1)<br />
	defer close(pipe)<br />
	go CallMe(pipe)<br />
	select {<br />
	case v, ok := &lt;-pipe:<br />
		if !ok {<br />
			fmt.Println(&quot;Read Error&quot;)<br />
		}<br />
		fmt.Println(v)<br />
	}<br />
}

</code></pre>
<p>是的，协程除了它要解决的问题上，其他可以说就是线程。</p>
<p>那么协程要解决什么问题呢？</p>
<p>这要从协程为什么火起来说起。线程池很好，但线程是由操作系统调度的，并且线程切换代价太大，往往需要耗费数千个CPU周期。</p>
<p>在同步阻塞的编程模式下，<br /><br />
当并发量很大、IO密集时，往往一个任务刚进入线程池就阻塞在IO，就可能(因为线程切换是不可控的)需要切换线程，这时线程切换的代价就不可以忽视了。</p>
<p>后来人们发现异步非阻塞的模型能解决这个问题，当被IO阻塞时，直接调用非阻塞接口，注册一个回调函数，当前线程继续进行，也就不用切换线程了。但理想很丰满，现实很骨感，异步的回调各种嵌套让程序员的人生更加悲惨。</p>
<p>于是协程应运重生。</p>
<p>协程就是由程序员控制跑在线程里的“微线程”。它可以由程序员调度，切换协程时代价小(切换根据实现不同，消耗的CPU周期从几十到几百不等)，创建时耗费资源小。十分适用IO密集的场景。</p>
<h2>Boost::Coroutine2</h2>
<p>boost的Coroutine2不同于Goroutine，golang的协程调度是由Go语言完成，而boost::coroutine2的协程需要自己去调度。</p>
<pre class="prettyprint linenums"><code>#include &lt;boost\coroutine2\all.hpp&gt;

#include &lt;cstdlib&gt;<br />
#include &lt;iostream&gt;

using namespace boost;<br />
using namespace std;

class X {<br />
public:<br />
	X() {<br />
		cout &lt;&lt; &quot;X()\n&quot;;<br />
	}<br />
	~X() {<br />
		cout &lt;&lt; &quot;~X()\n&quot;;<br />
		system(&quot;pause&quot;);<br />
	}<br />
};

void foo(boost::coroutines2::coroutine&lt;void&gt;::pull_type&amp; pull) {<br />
	X x;<br />
	cout &lt;&lt; &quot;a\n&quot;;<br />
	pull();<br />
	cout &lt;&lt; &quot;b\n&quot;;<br />
	pull();<br />
	cout &lt;&lt; &quot;c\n&quot;;<br />
}

int main() {<br />
	coroutines2::coroutine&lt;void&gt;::push_type push(foo);<br />
	cout &lt;&lt; &quot;1\n&quot;;<br />
	push();<br />
	cout &lt;&lt; &quot;2\n&quot;;<br />
	push();<br />
	cout &lt;&lt; &quot;3\n&quot;;<br />
	push();

	return 0;<br />
}<br />
</code></pre>
<p>调用push_type和pull_type的operator()就会让出当前执行流程给对应的协程。push_type可以给pull_type传递参数，而pull_type通过调用get来获取。</p>
<p>你也可以写成这样</p>
<pre class="prettyprint linenums"><code>boost::coroutines2::coroutine&lt;void&gt;::pull_type pull([](coroutine&lt;void&gt;::push_type &amp;push){...})<br />
</code></pre>
<p>它和上面的区别是，新建的pull_type会立即进入绑定的函数中(哪里可以调用push()，哪个协程先执行)</p>
<p>那如果在main结束之前，foo里没有执行完，那foo里的X会析构吗？<br /><br />
Boost文档里说会的，这个叫做<code>Stack unwinding</code>。<br /><br />
我们不妨把main函数里最后一个<code>push();</code>去掉，这样后面就不会切换到foo的context了。会发现虽然foo中的&quot;c&quot;没有输出，但X还是析构了的。</p>
<h2>Fiber</h2>
<p>在实际生产中，我们更适合用fiber来解决问题。fiber有调度器，使用简单，不需要手动控制执行流程。</p>
<pre class="prettyprint linenums"><code>#include &lt;boost\fiber\all.hpp&gt;

#include &lt;chrono&gt;<br />
#include &lt;string&gt;<br />
#include &lt;ctime&gt;<br />
#include &lt;iostream&gt;<br />
#include &lt;cstdlib&gt;

using namespace std;<br />
using namespace boost;

void callMe(fibers::buffered_channel&lt;string&gt;&amp; pipe) {<br />
	std::time_t result = std::time(nullptr);<br />
	string timestr = std::asctime(std::localtime(&amp;result));<br />
	pipe.push(timestr);<br />
}

int main() {<br />
	fibers::buffered_channel&lt;string&gt; pipe(2);<br />
	fibers::fiber f([&amp;]() {callMe(pipe); });<br />
	f.detach();<br />
	string str;<br />
	pipe.pop(str);<br />
	cout &lt;&lt; str &lt;&lt; &quot;\n&quot;;<br />
	system(&quot;pause&quot;);

	return 0;<br />
}<br />
</code></pre>
<p>boost::fibers是一个拥有调度器的协程。看上去fiber已经和goroutine完全一样了。在fiber里不能调用任何阻塞线程的接口，因为一旦当前fiber被阻塞，那意味着当前线程的所有fiber都被阻塞了。因此所有跟协程相关的阻塞接口都需要自己实现一套协程的包装，比如<code>this_fiber::sleep_for()</code>。这也意味着数据库之类的操作没办法被fiber中直接使用。但好在fiber提供了一系列方法去解决这个问题。</p>
<h3>使用非阻塞IO</h3>
<pre class="prettyprint linenums"><code>int read_chunk( NonblockingAPI &amp; api, std::string &amp; data, std::size_t desired) {<br />
    int error;<br />
    while ( EWOULDBLOCK == ( error = api.read( data, desired) ) ) {<br />
        boost::this_fiber::yield();<br />
    }<br />
    return error;<br />
}<br />
</code></pre>
<p>主要思想就是，当前fiber调用非阻塞api轮询，一旦发现该接口会阻塞，就调用<code>boost::this_fiber::yield()</code>让出执行权限给其他协程，知道下次获得执行权限，再次查看是否阻塞。</p>
<h3>异步IO</h3>
<pre class="prettyprint linenums"><code>std::pair&lt; AsyncAPI::errorcode, std::string &gt; read_ec( AsyncAPI &amp; api) {<br />
    typedef std::pair&lt; AsyncAPI::errorcode, std::string &gt; result_pair;<br />
    boost::fibers::promise&lt; result_pair &gt; promise;<br />
    boost::fibers::future&lt; result_pair &gt; future( promise.get_future() );<br />
    // We promise that both 'promise' and 'future' will survive until our lambda has been called.<br />
    // Need C++14<br />
    api.init_read([promise=std::move( promise)]( AsyncAPI::errorcode ec, std::string const&amp; data) mutable {<br />
                            promise.set_value( result_pair( ec, data) );<br />
                  });<br />
    return future.get();<br />
}<br />
</code></pre>
<p>这种实现方法主要是利用了异步IO不会阻塞当前fiber，在异步的回调中给<code>fibers::promise</code>设值。当异步操作未返回时，如果依赖到异步的结果，在调用<code>future.get()</code>时就会让出执行权限给其他协程。</p>
<h3>同步IO</h3>
<p>同步IO不可以直接应用到fiber中，因为会阻塞当前线程而导致线程所有的fiber都阻塞。</p>
<p>如果一个接口只有同步模式，比如官方的Mysql Connector，那我们只能先利用多线程模拟一个异步接口，然后再把它当做异步IO去处理。<br /><br />
如何用多线程把同步接口包装成异步接口呢？</p>
<p>如下，包装好后就可以利用上面异步IO的方法再包装一个fiber可以使用的IO接口。</p>
<pre class="prettyprint linenums"><code>#include &lt;boost/asio.hpp&gt;<br />
#include &lt;boost/fiber/all.hpp&gt;

#include &lt;string&gt;<br />
#include &lt;thread&gt;<br />
#include &lt;cstdlib&gt;

#include &lt;stdio.h&gt;

using namespace std;<br />
using namespace boost;

class AsyncWrapper<br />
{<br />
public:<br />
	void async_read(const string fileName, function&lt;void (const string &amp;)&gt; callback) {<br />
		auto fun = [=]() {<br />
			FILE* fp = fopen(fileName.c_str(), &quot;r&quot;);<br />
			char buff[1024];<br />
			string tmp;<br />
			while (nullptr != fgets(buff, 1024, fp)) {<br />
				tmp += buff;<br />
			}<br />
			fclose(fp);

			callback(tmp);<br />
		};<br />
		asio::post(pool, fun);<br />
	}

	static void wait() {<br />
		pool.join();<br />
	}

protected:<br />
	static asio::thread_pool pool;<br />
};

asio::thread_pool AsyncWrapper::pool(2);

int main()<br />
{<br />
	AsyncWrapper wrap;<br />
	string file = &quot;./temp.txt&quot;;<br />
	wrap.async_read(file, [](const string&amp; result) {printf(&quot;%s\n&quot;, result.c_str()); });

	AsyncWrapper::wait();

	std::system(&quot;pause&quot;);<br />
	return 0;<br />
}<br />
</code></pre>
<h3>golang方便在哪</h3>
<p>golang的好处就在于它已经帮你完成了上述的封装过程，它把所有的IO操作都封装成了阻塞同步调用模式，无非也是通过上面两种方法。这样程序员调用的时候 感觉自己在写同步的代码，但却能享受异步/非阻塞带来的好处。</p>
<p>例如</p>
<pre class="prettyprint linenums"><code>package main

import (<br />
	&quot;log&quot;<br />
	&quot;os&quot;<br />
	&quot;sync&quot;<br />
	&quot;time&quot;<br />
)

var wg sync.WaitGroup

func blockSleep() {<br />
	log.Printf(&quot;blockSleep Before bock----------&quot;)<br />
	time.Sleep(1 * time.Second)<br />
	log.Printf(&quot;blockSleep After bock----------&quot;)<br />
	wg.Done()<br />
}

func writeFile() {<br />
	log.Printf(&quot;writeFile Before bock+++++++++++&quot;)<br />
	f, _ := os.Create(&quot;./temp.txt&quot;)<br />
	defer f.Close()<br />
	log.Printf(&quot;writeFile Before Write+++++++++++&quot;)<br />
	f.WriteString(&quot;Hello World&quot;)<br />
	log.Printf(&quot;writeFile After bock+++++++++++&quot;)<br />
	wg.Done()<br />
}

func main() {<br />
	go writeFile()<br />
	wg.Add(1)<br />
	for i := 1; i &lt; 5; i++ {<br />
		go blockSleep()<br />
		wg.Add(1)<br />
	}<br />
	wg.Wait()<br />
}

</code></pre>
<p>这段代码<code>time.Sleep</code>和<code>os.Create</code>都会造成当前协程让出CPU。其输出如下</p>
<pre class="prettyprint linenums"><code>2018/05/31 13:53:19 blockSleep Before bock----------<br />
2018/05/31 13:53:19 blockSleep Before bock----------<br />
2018/05/31 13:53:19 writeFile Before bock+++++++++++<br />
2018/05/31 13:53:19 blockSleep Before bock----------<br />
2018/05/31 13:53:19 writeFile Before Write+++++++++++<br />
2018/05/31 13:53:19 writeFile After bock+++++++++++<br />
2018/05/31 13:53:19 blockSleep Before bock----------<br />
2018/05/31 13:53:20 blockSleep After bock----------<br />
2018/05/31 13:53:20 blockSleep After bock----------<br />
2018/05/31 13:53:20 blockSleep After bock----------<br />
2018/05/31 13:53:20 blockSleep After bock----------<br />
</code></pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/wq1r048g.html">RabbitMq应用一的补充（RabbitMQ的应用场景）</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqljnv19.html">Python3实现火车票查询工具</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2jlzw8.html">Codeforces Round &num;377 &lpar;Div&period; 2&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqv2wxj9.html">&lpar;十二&rpar; WebGIS中矢量图层的设计</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm5vn79.html">laravel速记（笔记）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd64x78.html">C&num; Distinct方法的使用笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj524k9.html">会话管理（Cookie&sol;Session技术）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkznmj8.html">Echarts数据可视化series-effectscatter特效散点图，开发全解&plus;完美注释</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zop2e9.html">BZOJ&lowbar;4813&lowbar;&lbrack;Cqoi2017&rsqb;小Q的棋盘&lowbar;dfs</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpe3079.html">2017-2018年Scrum状态调查报告</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mgknm8.html">Nginx配置http跳转https访问</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdzgjd9.html">jmeter笔记（3）--响应结果中文乱码的解决方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25djpvq.html">jsp中的绝对路径、相对路径和访问jsp的方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2k5epq.html">Tomcat报错： Failed to start component &lbrack;StandardEngine&lbrack;Catalina&rsqb;&period;StandardHost&lbrack;localhost&rsqb;&period;StandardContext&lbrack;&sol;myApp&rsqb;&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gl34eq.html">vuex数据持久化存储</a>
		</li>
						<li><a href="https://www.batexi.com/a/963pjn39.html">Xtreme9&period;0 - Light Gremlins 容斥</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql15yx09.html">【刷题】Search in a Big Sorted Array</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnnwj7xq.html">trsd&lowbar;extract&lowbar;EDSD&lowbar;new</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2kyl5lq.html">&lbrack;2019BUAA软件工程&rsqb;第0次个人作业</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2ke5k3q.html">enter快捷键盘</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9r5d6lrq.html">laravel seed填充数据步骤</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pwj7zd8.html">wireshark相关知识</a>
			</li>
						<li><a href="https://www.batexi.com/a/95gx7pmq.html">YouTube数据：谁获得了最多订阅者？</a>
			</li>
						<li><a href="https://www.batexi.com/a/90rvkw39.html">学习笔记CB002&colon;词干提取、词性标注、中文切词、文档分类</a>
			</li>
						<li><a href="https://www.batexi.com/a/90rv1em9.html">Temporary failure in name resolutionf的解决方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/90rvl739.html">Assembly Experiment4</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyydxdxq.html">引擎设计跟踪&lpar;九&period;14&period;3&period;4&rpar; mile stone 2 - model和fbx导入的补漏</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r5d32mq.html">详解在Linux下实现&lpar;彩色&rpar;进度条程序，并通过makefile进行编译&period;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gjm0nz9.html">python获取机器信息脚本&lpar;网上寻找的&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2nvooq.html">zabbix和iptables的nat表结合使用</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
